/**
 * .jsx for AdobeIllustrator. Marat Shagiev. 14.09.2014. WebStorm 8.0.4
 */

//@target illustrator

// вызов/применение
delEmptyLays();

// ф-ция удаления всех пустых слоёв-подслоёв
function delEmptyLays() {

  for (var i = 0; i < activeDocument.layers.length; i++) {
    var lay = activeDocument.layers[i];
    if (_hasSubs(lay)) {
      _delSubs(lay);
    }
    if (_isEmpty(lay) && activeDocument.layers.length > 1) {
      lay.remove();
      i--;
    }
  }

  /**
   * HELPERS
   * */

  function _delSubs(lay) {
    for (var i = 0; i < lay.layers.length; i++) {
      var that = _getSubs(lay)[i];
      if (_isEmpty(that)) {
        that.remove();
        i--;
      }
      if (_hasSubs(that)) {
        var parent = _delSubs(that);
        if (_isEmpty(parent)) {
          that.remove();
          i--;
        }
      }
    }
    return lay;
  }

  function _hasSubs(lay) {
    try {
      return (lay.layers.length > 0);
    } catch (e) {
      return false;
    }
  }

  function _hasItems(lay) {
    try {
      return (lay.pageItems.length > 0);
    } catch (e) {
      return false;
    }
  }

  function _isEmpty(lay) {
    try {
      return lay.pageItems.length == 0 && lay.layers.length == 0;
    } catch (e) {
      return false;
    }
  }

  function _getSubs(lay) {
    try {
      return lay.layers;
    } catch (e) {
      return false;
    }
  }
}